diff --git a/external/fmt/test/format-test.cc b/external/fmt/test/format-test.cc
index 2a25566c..a8592ef0 100644
--- a/external/fmt/test/format-test.cc
+++ b/external/fmt/test/format-test.cc
@@ -2012,269 +1983,13 @@ struct test_output_iterator {
   char& operator*() { return *data; }
 };
 
-TEST(FormatTest, FormatToNOutputIterator) {
+TEST(format_test, format_to_n_output_iterator) {
   char buf[10] = {};
   fmt::format_to_n(test_output_iterator{buf}, 10, "{}", 42);
   EXPECT_STREQ(buf, "42");
 }
 
 #if FMT_USE_CONSTEXPR
-struct test_arg_id_handler {
-  enum result { NONE, EMPTY, INDEX, NAME, ERROR };
-  result res = NONE;
-  int index = 0;
-  string_view name;
-
-  FMT_CONSTEXPR void operator()() { res = EMPTY; }
-
-  FMT_CONSTEXPR void operator()(int i) {
-    res = INDEX;
-    index = i;
-  }
-
-  FMT_CONSTEXPR void operator()(string_view n) {
-    res = NAME;
-    name = n;
-  }
-
-  FMT_CONSTEXPR void on_error(const char*) { res = ERROR; }
-};
-
-template <size_t N>
-FMT_CONSTEXPR test_arg_id_handler parse_arg_id(const char (&s)[N]) {
-  test_arg_id_handler h;
-  fmt::detail::parse_arg_id(s, s + N, h);
-  return h;
-}
-
-TEST(FormatTest, ConstexprParseArgID) {
-  static_assert(parse_arg_id(":").res == test_arg_id_handler::EMPTY, "");
-  static_assert(parse_arg_id("}").res == test_arg_id_handler::EMPTY, "");
-  static_assert(parse_arg_id("42:").res == test_arg_id_handler::INDEX, "");
-  static_assert(parse_arg_id("42:").index == 42, "");
-  static_assert(parse_arg_id("foo:").res == test_arg_id_handler::NAME, "");
-  static_assert(parse_arg_id("foo:").name.size() == 3, "");
-  static_assert(parse_arg_id("!").res == test_arg_id_handler::ERROR, "");
-}
-
-struct test_format_specs_handler {
-  enum Result { NONE, PLUS, MINUS, SPACE, HASH, ZERO, ERROR };
-  Result res = NONE;
-
-  fmt::align_t align = fmt::align::none;
-  char fill = 0;
-  int width = 0;
-  fmt::detail::arg_ref<char> width_ref;
-  int precision = 0;
-  fmt::detail::arg_ref<char> precision_ref;
-  char type = 0;
-
-  // Workaround for MSVC2017 bug that results in "expression did not evaluate
-  // to a constant" with compiler-generated copy ctor.
-  FMT_CONSTEXPR test_format_specs_handler() {}
-  FMT_CONSTEXPR test_format_specs_handler(
-      const test_format_specs_handler& other)
-      : res(other.res),
-        align(other.align),
-        fill(other.fill),
-        width(other.width),
-        width_ref(other.width_ref),
-        precision(other.precision),
-        precision_ref(other.precision_ref),
-        type(other.type) {}
-
-  FMT_CONSTEXPR void on_align(fmt::align_t a) { align = a; }
-  FMT_CONSTEXPR void on_fill(fmt::string_view f) { fill = f[0]; }
-  FMT_CONSTEXPR void on_plus() { res = PLUS; }
-  FMT_CONSTEXPR void on_minus() { res = MINUS; }
-  FMT_CONSTEXPR void on_space() { res = SPACE; }
-  FMT_CONSTEXPR void on_hash() { res = HASH; }
-  FMT_CONSTEXPR void on_zero() { res = ZERO; }
-
-  FMT_CONSTEXPR void on_width(int w) { width = w; }
-  FMT_CONSTEXPR void on_dynamic_width(fmt::detail::auto_id) {}
-  FMT_CONSTEXPR void on_dynamic_width(int index) { width_ref = index; }
-  FMT_CONSTEXPR void on_dynamic_width(string_view) {}
-
-  FMT_CONSTEXPR void on_precision(int p) { precision = p; }
-  FMT_CONSTEXPR void on_dynamic_precision(fmt::detail::auto_id) {}
-  FMT_CONSTEXPR void on_dynamic_precision(int index) { precision_ref = index; }
-  FMT_CONSTEXPR void on_dynamic_precision(string_view) {}
-
-  FMT_CONSTEXPR void end_precision() {}
-  FMT_CONSTEXPR void on_type(char t) { type = t; }
-  FMT_CONSTEXPR void on_error(const char*) { res = ERROR; }
-};
-
-template <size_t N>
-FMT_CONSTEXPR test_format_specs_handler parse_test_specs(const char (&s)[N]) {
-  test_format_specs_handler h;
-  fmt::detail::parse_format_specs(s, s + N, h);
-  return h;
-}
-
-TEST(FormatTest, ConstexprParseFormatSpecs) {
-  typedef test_format_specs_handler handler;
-  static_assert(parse_test_specs("<").align == fmt::align::left, "");
-  static_assert(parse_test_specs("*^").fill == '*', "");
-  static_assert(parse_test_specs("+").res == handler::PLUS, "");
-  static_assert(parse_test_specs("-").res == handler::MINUS, "");
-  static_assert(parse_test_specs(" ").res == handler::SPACE, "");
-  static_assert(parse_test_specs("#").res == handler::HASH, "");
-  static_assert(parse_test_specs("0").res == handler::ZERO, "");
-  static_assert(parse_test_specs("42").width == 42, "");
-  static_assert(parse_test_specs("{42}").width_ref.val.index == 42, "");
-  static_assert(parse_test_specs(".42").precision == 42, "");
-  static_assert(parse_test_specs(".{42}").precision_ref.val.index == 42, "");
-  static_assert(parse_test_specs("d").type == 'd', "");
-  static_assert(parse_test_specs("{<").res == handler::ERROR, "");
-}
-
-struct test_parse_context {
-  typedef char char_type;
-
-  FMT_CONSTEXPR int next_arg_id() { return 11; }
-  template <typename Id> FMT_CONSTEXPR void check_arg_id(Id) {}
-
-  FMT_CONSTEXPR const char* begin() { return nullptr; }
-  FMT_CONSTEXPR const char* end() { return nullptr; }
-
-  void on_error(const char*) {}
-};
-
-struct test_context {
-  using char_type = char;
-  using format_arg = fmt::basic_format_arg<test_context>;
-  using parse_context_type = fmt::format_parse_context;
-
-  template <typename T> struct formatter_type {
-    typedef fmt::formatter<T, char_type> type;
-  };
-
-  template <typename Id>
-  FMT_CONSTEXPR fmt::basic_format_arg<test_context> arg(Id id) {
-    return fmt::detail::make_arg<test_context>(id);
-  }
-
-  void on_error(const char*) {}
-
-  FMT_CONSTEXPR test_context error_handler() { return *this; }
-};
-
-template <size_t N>
-FMT_CONSTEXPR fmt::format_specs parse_specs(const char (&s)[N]) {
-  auto specs = fmt::format_specs();
-  auto parse_ctx = test_parse_context();
-  auto ctx = test_context();
-  fmt::detail::specs_handler<test_parse_context, test_context> h(
-      specs, parse_ctx, ctx);
-  parse_format_specs(s, s + N, h);
-  return specs;
-}
-
-TEST(FormatTest, ConstexprSpecsHandler) {
-  static_assert(parse_specs("<").align == fmt::align::left, "");
-  static_assert(parse_specs("*^").fill[0] == '*', "");
-  static_assert(parse_specs("+").sign == fmt::sign::plus, "");
-  static_assert(parse_specs("-").sign == fmt::sign::minus, "");
-  static_assert(parse_specs(" ").sign == fmt::sign::space, "");
-  static_assert(parse_specs("#").alt, "");
-  static_assert(parse_specs("0").align == fmt::align::numeric, "");
-  static_assert(parse_specs("42").width == 42, "");
-  static_assert(parse_specs("{}").width == 11, "");
-  static_assert(parse_specs("{22}").width == 22, "");
-  static_assert(parse_specs(".42").precision == 42, "");
-  static_assert(parse_specs(".{}").precision == 11, "");
-  static_assert(parse_specs(".{22}").precision == 22, "");
-  static_assert(parse_specs("d").type == 'd', "");
-}
-
-template <size_t N>
-FMT_CONSTEXPR fmt::detail::dynamic_format_specs<char> parse_dynamic_specs(
-    const char (&s)[N]) {
-  fmt::detail::dynamic_format_specs<char> specs;
-  test_parse_context ctx{};
-  fmt::detail::dynamic_specs_handler<test_parse_context> h(specs, ctx);
-  parse_format_specs(s, s + N, h);
-  return specs;
-}
-
-TEST(FormatTest, ConstexprDynamicSpecsHandler) {
-  static_assert(parse_dynamic_specs("<").align == fmt::align::left, "");
-  static_assert(parse_dynamic_specs("*^").fill[0] == '*', "");
-  static_assert(parse_dynamic_specs("+").sign == fmt::sign::plus, "");
-  static_assert(parse_dynamic_specs("-").sign == fmt::sign::minus, "");
-  static_assert(parse_dynamic_specs(" ").sign == fmt::sign::space, "");
-  static_assert(parse_dynamic_specs("#").alt, "");
-  static_assert(parse_dynamic_specs("0").align == fmt::align::numeric, "");
-  static_assert(parse_dynamic_specs("42").width == 42, "");
-  static_assert(parse_dynamic_specs("{}").width_ref.val.index == 11, "");
-  static_assert(parse_dynamic_specs("{42}").width_ref.val.index == 42, "");
-  static_assert(parse_dynamic_specs(".42").precision == 42, "");
-  static_assert(parse_dynamic_specs(".{}").precision_ref.val.index == 11, "");
-  static_assert(parse_dynamic_specs(".{42}").precision_ref.val.index == 42, "");
-  static_assert(parse_dynamic_specs("d").type == 'd', "");
-}
-
-template <size_t N>
-FMT_CONSTEXPR test_format_specs_handler check_specs(const char (&s)[N]) {
-  fmt::detail::specs_checker<test_format_specs_handler> checker(
-      test_format_specs_handler(), fmt::detail::type::double_type);
-  parse_format_specs(s, s + N, checker);
-  return checker;
-}
-
-TEST(FormatTest, ConstexprSpecsChecker) {
-  typedef test_format_specs_handler handler;
-  static_assert(check_specs("<").align == fmt::align::left, "");
-  static_assert(check_specs("*^").fill == '*', "");
-  static_assert(check_specs("+").res == handler::PLUS, "");
-  static_assert(check_specs("-").res == handler::MINUS, "");
-  static_assert(check_specs(" ").res == handler::SPACE, "");
-  static_assert(check_specs("#").res == handler::HASH, "");
-  static_assert(check_specs("0").res == handler::ZERO, "");
-  static_assert(check_specs("42").width == 42, "");
-  static_assert(check_specs("{42}").width_ref.val.index == 42, "");
-  static_assert(check_specs(".42").precision == 42, "");
-  static_assert(check_specs(".{42}").precision_ref.val.index == 42, "");
-  static_assert(check_specs("d").type == 'd', "");
-  static_assert(check_specs("{<").res == handler::ERROR, "");
-}
-
-struct test_format_string_handler {
-  FMT_CONSTEXPR void on_text(const char*, const char*) {}
-
-  FMT_CONSTEXPR int on_arg_id() { return 0; }
-
-  template <typename T> FMT_CONSTEXPR int on_arg_id(T) { return 0; }
-
-  FMT_CONSTEXPR void on_replacement_field(int, const char*) {}
-
-  FMT_CONSTEXPR const char* on_format_specs(int, const char* begin,
-                                            const char*) {
-    return begin;
-  }
-
-  FMT_CONSTEXPR void on_error(const char*) { error = true; }
-
-  bool error = false;
-};
-
-template <size_t N> FMT_CONSTEXPR bool parse_string(const char (&s)[N]) {
-  test_format_string_handler h;
-  fmt::detail::parse_format_string<true>(fmt::string_view(s, N - 1), h);
-  return !h.error;
-}
-
-TEST(FormatTest, ConstexprParseFormatString) {
-  static_assert(parse_string("foo"), "");
-  static_assert(!parse_string("}"), "");
-  static_assert(parse_string("{}"), "");
-  static_assert(parse_string("{42}"), "");
-  static_assert(parse_string("{foo}"), "");
-  static_assert(parse_string("{:}"), "");
-}
-
 struct test_error_handler {
   const char*& error;
 
@@ -2306,9 +2021,10 @@ FMT_CONSTEXPR bool equal(const char* s1, const char* s2) {
 template <typename... Args>
 FMT_CONSTEXPR bool test_error(const char* fmt, const char* expected_error) {
   const char* actual_error = nullptr;
-  string_view s(fmt, len(fmt));
-  fmt::detail::format_string_checker<char, test_error_handler, Args...> checker(
-      s, test_error_handler(actual_error));
+  auto s = string_view(fmt, len(fmt));
+  auto checker =
+      fmt::detail::format_string_checker<char, test_error_handler, Args...>(
+          s, test_error_handler(actual_error));
   fmt::detail::parse_format_string<true>(s, checker);
   return equal(actual_error, expected_error);
 }
@@ -2318,21 +2034,16 @@ FMT_CONSTEXPR bool test_error(const char* fmt, const char* expected_error) {
 #  define EXPECT_ERROR(fmt, error, ...) \
     static_assert(test_error<__VA_ARGS__>(fmt, error), "")
 
-TEST(FormatTest, FormatStringErrors) {
+TEST(format_test, format_string_errors) {
   EXPECT_ERROR_NOARGS("foo", nullptr);
   EXPECT_ERROR_NOARGS("}", "unmatched '}' in format string");
-  EXPECT_ERROR("{0:s", "unknown format specifier", Date);
+  EXPECT_ERROR("{0:s", "unknown format specifier", date);
 #  if !FMT_MSC_VER || FMT_MSC_VER >= 1916
   // This causes an detail compiler error in MSVC2017.
   EXPECT_ERROR("{:{<}", "invalid fill character '{'", int);
   EXPECT_ERROR("{:10000000000}", "number is too big", int);
   EXPECT_ERROR("{:.10000000000}", "number is too big", int);
   EXPECT_ERROR_NOARGS("{:x}", "argument not found");
-#    if FMT_DEPRECATED_NUMERIC_ALIGN
-  EXPECT_ERROR("{0:=5", "unknown format specifier", int);
-  EXPECT_ERROR("{:=}", "format specifier requires numeric argument",
-               const char*);
-#    endif
   EXPECT_ERROR("{:+}", "format specifier requires numeric argument",
                const char*);
   EXPECT_ERROR("{:-}", "format specifier requires numeric argument",
@@ -2350,7 +2061,6 @@ TEST(FormatTest, FormatStringErrors) {
   EXPECT_ERROR("{:.{}}", "argument not found", double);
   EXPECT_ERROR("{:.2}", "precision not allowed for this argument type", int);
   EXPECT_ERROR("{:s}", "invalid type specifier", int);
-  EXPECT_ERROR("{:s}", "invalid type specifier", bool);
   EXPECT_ERROR("{:s}", "invalid type specifier", char);
   EXPECT_ERROR("{:+}", "invalid format specifier for char", char);
   EXPECT_ERROR("{:s}", "invalid type specifier", double);
@@ -2360,9 +2070,16 @@ TEST(FormatTest, FormatStringErrors) {
 #  else
   fmt::print("warning: constexpr is broken in this version of MSVC\n");
 #  endif
-  EXPECT_ERROR("{foo", "compile-time checks don't support named arguments",
+#  if FMT_USE_NONTYPE_TEMPLATE_PARAMETERS
+  EXPECT_ERROR("{foo}", "named argument is not found", decltype("bar"_a = 42));
+  EXPECT_ERROR("{foo}", "named argument is not found",
+               decltype(fmt::arg("foo", 42)));
+#  else
+  EXPECT_ERROR("{foo}",
+               "compile-time checks for named arguments require C++20 support",
                int);
-  EXPECT_ERROR_NOARGS("{10000000000}", "number is too big");
+#  endif
+  EXPECT_ERROR_NOARGS("{10000000000}", "argument not found");
   EXPECT_ERROR_NOARGS("{0x}", "invalid format string");
   EXPECT_ERROR_NOARGS("{-}", "invalid format string");
   EXPECT_ERROR("{:{0x}}", "invalid format string", int);
@@ -2380,90 +2097,94 @@ TEST(FormatTest, FormatStringErrors) {
                int);
 }
 
-TEST(FormatTest, VFormatTo) {
-  typedef fmt::format_context context;
+TEST(format_test, vformat_to) {
+  using context = fmt::format_context;
   fmt::basic_format_arg<context> arg = fmt::detail::make_arg<context>(42);
-  fmt::basic_format_args<context> args(&arg, 1);
-  std::string s;
+  auto args = fmt::basic_format_args<context>(&arg, 1);
+  auto s = std::string();
   fmt::vformat_to(std::back_inserter(s), "{}", args);
   EXPECT_EQ("42", s);
   s.clear();
   fmt::vformat_to(std::back_inserter(s), FMT_STRING("{}"), args);
   EXPECT_EQ("42", s);
-
-  typedef fmt::wformat_context wcontext;
-  fmt::basic_format_arg<wcontext> warg = fmt::detail::make_arg<wcontext>(42);
-  fmt::basic_format_args<wcontext> wargs(&warg, 1);
-  std::wstring w;
-  fmt::vformat_to(std::back_inserter(w), L"{}", wargs);
-  EXPECT_EQ(L"42", w);
-  w.clear();
-  fmt::vformat_to(std::back_inserter(w), FMT_STRING(L"{}"), wargs);
-  EXPECT_EQ(L"42", w);
-}
-
-template <typename T> static std::string FmtToString(const T& t) {
-  return fmt::format(FMT_STRING("{}"), t);
-}
-
-TEST(FormatTest, FmtStringInTemplate) {
-  EXPECT_EQ(FmtToString(1), "1");
-  EXPECT_EQ(FmtToString(0), "0");
 }
 
 #endif  // FMT_USE_CONSTEXPR
 
-TEST(FormatTest, EmphasisNonHeaderOnly) {
-  // Ensure this compiles even if FMT_HEADER_ONLY is not defined.
-  EXPECT_EQ(fmt::format(fmt::emphasis::bold, "bold error"),
-            "\x1b[1mbold error\x1b[0m");
-}
-
-TEST(FormatTest, CharTraitsIsNotAmbiguous) {
+TEST(format_test, char_traits_is_not_ambiguous) {
   // Test that we don't inject detail names into the std namespace.
   using namespace std;
-  char_traits<char>::char_type c;
+  auto c = char_traits<char>::char_type();
   (void)c;
 #if __cplusplus >= 201103L
-  std::string s;
+  auto s = std::string();
   auto lval = begin(s);
   (void)lval;
 #endif
 }
 
-struct mychar {
-  int value;
-  mychar() = default;
+struct check_back_appender {};
 
-  template <typename T> mychar(T val) : value(static_cast<int>(val)) {}
+FMT_BEGIN_NAMESPACE
+template <> struct formatter<check_back_appender> {
+  auto parse(format_parse_context& ctx) -> decltype(ctx.begin()) {
+    return ctx.begin();
+  }
 
-  operator int() const { return value; }
+  template <typename Context>
+  auto format(check_back_appender, Context& ctx) -> decltype(ctx.out()) {
+    auto out = ctx.out();
+    static_assert(std::is_same<decltype(++out), decltype(out)&>::value,
+                  "needs to satisfy weakly_incrementable");
+    *out = 'y';
+    return ++out;
+  }
 };
-
-FMT_BEGIN_NAMESPACE
-template <> struct is_char<mychar> : std::true_type {};
 FMT_END_NAMESPACE
 
-TEST(FormatTest, FormatCustomChar) {
-  const mychar format[] = {'{', '}', 0};
-  auto result = fmt::format(format, mychar('x'));
-  EXPECT_EQ(result.size(), 1);
-  EXPECT_EQ(result[0], mychar('x'));
+TEST(format_test, back_insert_slicing) {
+  EXPECT_EQ(fmt::format("{}", check_back_appender{}), "y");
+}
+
+template <typename Char, typename T> bool check_enabled_formatter() {
+  static_assert(std::is_default_constructible<fmt::formatter<T, Char>>::value,
+                "");
+  return true;
+}
+
+template <typename Char, typename... T> void check_enabled_formatters() {
+  auto dummy = {check_enabled_formatter<Char, T>()...};
+  (void)dummy;
 }
 
-// Convert a char8_t string to std::string. Otherwise GTest will insist on
-// inserting `char8_t` NTBS into a `char` stream which is disabled by P1423.
-template <typename S> std::string from_u8str(const S& str) {
-  return std::string(str.begin(), str.end());
+TEST(format_test, test_formatters_enabled) {
+  check_enabled_formatters<char, bool, char, signed char, unsigned char, short,
+                           unsigned short, int, unsigned, long, unsigned long,
+                           long long, unsigned long long, float, double,
+                           long double, void*, const void*, char*, const char*,
+                           std::string, std::nullptr_t>();
+  check_enabled_formatters<wchar_t, bool, wchar_t, signed char, unsigned char,
+                           short, unsigned short, int, unsigned, long,
+                           unsigned long, long long, unsigned long long, float,
+                           double, long double, void*, const void*, wchar_t*,
+                           const wchar_t*, std::wstring, std::nullptr_t>();
 }
 
-TEST(FormatTest, FormatUTF8Precision) {
-  using str_type = std::basic_string<fmt::detail::char8_type>;
-  str_type format(reinterpret_cast<const fmt::detail::char8_type*>(u8"{:.4}"));
-  str_type str(reinterpret_cast<const fmt::detail::char8_type*>(
-      u8"caf\u00e9s"));  // cafés
-  auto result = fmt::format(format, str);
-  EXPECT_EQ(fmt::detail::count_code_points(result), 4);
-  EXPECT_EQ(result.size(), 5);
-  EXPECT_EQ(from_u8str(result), from_u8str(str.substr(0, 5)));
+TEST(format_int_test, data) {
+  fmt::format_int format_int(42);
+  EXPECT_EQ("42", std::string(format_int.data(), format_int.size()));
+}
+
+TEST(format_int_test, format_int) {
+  EXPECT_EQ("42", fmt::format_int(42).str());
+  EXPECT_EQ(2u, fmt::format_int(42).size());
+  EXPECT_EQ("-42", fmt::format_int(-42).str());
+  EXPECT_EQ(3u, fmt::format_int(-42).size());
+  EXPECT_EQ("42", fmt::format_int(42ul).str());
+  EXPECT_EQ("-42", fmt::format_int(-42l).str());
+  EXPECT_EQ("42", fmt::format_int(42ull).str());
+  EXPECT_EQ("-42", fmt::format_int(-42ll).str());
+  std::ostringstream os;
+  os << max_value<int64_t>();
+  EXPECT_EQ(os.str(), fmt::format_int(max_value<int64_t>()).str());
 }
diff --git a/external/fmt/test/fuzzing/CMakeLists.txt b/external/fmt/test/fuzzing/CMakeLists.txt
index 31344fc5..0280c5cd 100644
--- a/external/fmt/test/fuzzing/CMakeLists.txt
+++ b/external/fmt/test/fuzzing/CMakeLists.txt
@@ -1,38 +1,30 @@
 # Copyright (c) 2019, Paul Dreik
 # License: see LICENSE.rst in the fmt root directory
 
-# settings this links in a main. useful for reproducing,
-# kcov, gdb, afl, valgrind.
-# (note that libFuzzer can also reproduce, just pass it the files)
-option(FMT_FUZZ_LINKMAIN "enables the reproduce mode, instead of libFuzzer" On)
+# Link in the main function. Useful for reproducing, kcov, gdb, afl, valgrind.
+# (Note that libFuzzer can also reproduce, just pass it the files.)
+option(FMT_FUZZ_LINKMAIN "Enables the reproduce mode, instead of libFuzzer" On)
 
 # For oss-fuzz - insert $LIB_FUZZING_ENGINE into the link flags, but only for
-# the fuzz targets, otherwise the cmake configuration step fails.
+# the fuzz targets, otherwise the CMake configuration step fails.
 set(FMT_FUZZ_LDFLAGS "" CACHE STRING "LDFLAGS for the fuzz targets")
 
-# Find all fuzzers.
-set(SOURCES
-  chrono_duration.cpp
-  named_arg.cpp
-  one_arg.cpp
-  sprintf.cpp
-  two_args.cpp
-)
-
-macro(implement_fuzzer sourcefile)
-  get_filename_component(basename ${sourcefile} NAME_WE)
-  set(name fuzzer_${basename})
-  add_executable(${name} ${sourcefile} fuzzer_common.h)
+# Adds a binary for reproducing, i.e. no fuzzing, just enables replaying data
+# through the fuzzers.
+function(add_fuzzer source)
+  get_filename_component(basename ${source} NAME_WE)
+  set(name ${basename}-fuzzer)
+  add_executable(${name} ${source} fuzzer-common.h)
   if (FMT_FUZZ_LINKMAIN)
-      target_sources(${name} PRIVATE main.cpp)
+    target_sources(${name} PRIVATE main.cc)
   endif ()
   target_link_libraries(${name} PRIVATE fmt)
-if (FMT_FUZZ_LDFLAGS)
-  target_link_libraries(${name} PRIVATE ${FMT_FUZZ_LDFLAGS})
-endif ()
+  if (FMT_FUZZ_LDFLAGS)
+    target_link_libraries(${name} PRIVATE ${FMT_FUZZ_LDFLAGS})
+  endif ()
   target_compile_features(${name} PRIVATE cxx_generic_lambdas)
-endmacro ()
+endfunction()
 
-foreach (X IN ITEMS ${SOURCES})
-  implement_fuzzer(${X})
+foreach (source chrono-duration.cc chrono-timepoint.cc float.cc named-arg.cc one-arg.cc two-args.cc)
+  add_fuzzer(${source})
 endforeach ()
diff --git a/external/fmt/test/fuzzing/build.sh b/external/fmt/test/fuzzing/build.sh
index 141a50d9..4497b62c 100755
--- a/external/fmt/test/fuzzing/build.sh
+++ b/external/fmt/test/fuzzing/build.sh
@@ -1,7 +1,6 @@
 #!/bin/sh
 #
 # Creates fuzzer builds of various kinds
-# - reproduce mode (no fuzzing, just enables replaying data through the fuzzers)
 # - oss-fuzz emulated mode (makes sure a simulated invocation by oss-fuzz works)
 # - libFuzzer build (you will need clang)
 # - afl build (you will need afl)
@@ -9,7 +8,7 @@
 #
 # Copyright (c) 2019 Paul Dreik
 #
-# License: see LICENSE.rst in the fmt root directory
+# For the license information refer to format.h.
 
 set -e
 me=$(basename $0)
@@ -23,16 +22,9 @@ here=$(pwd)
 CXXFLAGSALL="-DFUZZING_BUILD_MODE_UNSAFE_FOR_PRODUCTION= -g"
 CMAKEFLAGSALL="$root -GNinja -DCMAKE_BUILD_TYPE=Debug -DFMT_DOC=Off -DFMT_TEST=Off -DFMT_FUZZ=On -DCMAKE_CXX_STANDARD=17"
 
-#builds the fuzzers as one would do if using afl or just making
-#binaries for reproducing.
-builddir=$here/build-fuzzers-reproduce
-mkdir -p $builddir
-cd $builddir
-CXX="ccache g++" CXXFLAGS="$CXXFLAGSALL" cmake \
-$CMAKEFLAGSALL
-cmake --build $builddir
+CLANG=clang++-11
 
-#for performance analysis of the fuzzers
+# For performance analysis of the fuzzers.
 builddir=$here/build-fuzzers-perfanalysis
 mkdir -p $builddir
 cd $builddir
@@ -43,11 +35,11 @@ $CMAKEFLAGSALL \
 
 cmake --build $builddir
 
-#builds the fuzzers as oss-fuzz does
+# Builds the fuzzers as oss-fuzz does.
 builddir=$here/build-fuzzers-ossfuzz
 mkdir -p $builddir
 cd $builddir
-CXX="clang++" \
+CXX=$CLANG \
 CXXFLAGS="$CXXFLAGSALL -fsanitize=fuzzer-no-link" cmake \
 cmake $CMAKEFLAGSALL \
 -DFMT_FUZZ_LINKMAIN=Off \
@@ -56,11 +48,11 @@ cmake $CMAKEFLAGSALL \
 cmake --build $builddir
 
 
-#builds fuzzers for local fuzzing with libfuzzer with asan+usan
+# Builds fuzzers for local fuzzing with libfuzzer with asan+usan.
 builddir=$here/build-fuzzers-libfuzzer
 mkdir -p $builddir
 cd $builddir
-CXX="clang++" \
+CXX=$CLANG \
 CXXFLAGS="$CXXFLAGSALL -fsanitize=fuzzer-no-link,address,undefined" cmake \
 cmake $CMAKEFLAGSALL \
 -DFMT_FUZZ_LINKMAIN=Off \
@@ -68,23 +60,11 @@ cmake $CMAKEFLAGSALL \
 
 cmake --build $builddir
 
-#builds fuzzers for local fuzzing with libfuzzer with asan only
-builddir=$here/build-fuzzers-libfuzzer-addr
-mkdir -p $builddir
-cd $builddir
-CXX="clang++" \
-CXXFLAGS="$CXXFLAGSALL -fsanitize=fuzzer-no-link,undefined" cmake \
-cmake $CMAKEFLAGSALL \
--DFMT_FUZZ_LINKMAIN=Off \
--DFMT_FUZZ_LDFLAGS="-fsanitize=fuzzer"
-
-cmake --build $builddir
-
-#builds a fast fuzzer for making coverage fast
+# Builds a fast fuzzer for making coverage fast.
 builddir=$here/build-fuzzers-fast
 mkdir -p $builddir
 cd $builddir
-CXX="clang++" \
+CXX=$CLANG \
 CXXFLAGS="$CXXFLAGSALL -fsanitize=fuzzer-no-link -O3" cmake \
 cmake $CMAKEFLAGSALL \
 -DFMT_FUZZ_LINKMAIN=Off \
@@ -94,7 +74,7 @@ cmake $CMAKEFLAGSALL \
 cmake --build $builddir
 
 
-#builds fuzzers for local fuzzing with afl
+# Builds fuzzers for local fuzzing with afl.
 builddir=$here/build-fuzzers-afl
 mkdir -p $builddir
 cd $builddir
diff --git a/external/fmt/test/fuzzing/chrono-duration.cc b/external/fmt/test/fuzzing/chrono-duration.cc
new file mode 100644
index 00000000..d66068d9
--- /dev/null
+++ b/external/fmt/test/fuzzing/chrono-duration.cc
@@ -0,0 +1,136 @@
+// Copyright (c) 2019, Paul Dreik
+// For the license information refer to format.h.
+
+#include <fmt/chrono.h>
+
+#include <cstdint>
+
+#include "fuzzer-common.h"
+
+template <typename Period, typename Rep>
+void invoke_inner(fmt::string_view format_str, Rep rep) {
+  auto value = std::chrono::duration<Rep, Period>(rep);
+  try {
+#if FMT_FUZZ_FORMAT_TO_STRING
+    std::string message = fmt::format(format_str, value);
+#else
+    auto buf = fmt::memory_buffer();
+    fmt::format_to(std::back_inserter(buf), format_str, value);
+#endif
+  } catch (std::exception&) {
+  }
+}
+
+// Rep is a duration's representation type.
+template <typename Rep>
+void invoke_outer(const uint8_t* data, size_t size, int period) {
+  // Always use a fixed location of the data.
+  static_assert(sizeof(Rep) <= fixed_size, "fixed size is too small");
+  if (size <= fixed_size + 1) return;
+
+  const Rep rep = assign_from_buf<Rep>(data);
+  data += fixed_size;
+  size -= fixed_size;
+
+  // data is already allocated separately in libFuzzer so reading past the end
+  // will most likely be detected anyway.
+  const auto format_str = fmt::string_view(as_chars(data), size);
+
+  // yocto, zepto, zetta and yotta are not handled.
+  switch (period) {
+  case 1:
+    invoke_inner<std::atto>(format_str, rep);
+    break;
+  case 2:
+    invoke_inner<std::femto>(format_str, rep);
+    break;
+  case 3:
+    invoke_inner<std::pico>(format_str, rep);
+    break;
+  case 4:
+    invoke_inner<std::nano>(format_str, rep);
+    break;
+  case 5:
+    invoke_inner<std::micro>(format_str, rep);
+    break;
+  case 6:
+    invoke_inner<std::milli>(format_str, rep);
+    break;
+  case 7:
+    invoke_inner<std::centi>(format_str, rep);
+    break;
+  case 8:
+    invoke_inner<std::deci>(format_str, rep);
+    break;
+  case 9:
+    invoke_inner<std::deca>(format_str, rep);
+    break;
+  case 10:
+    invoke_inner<std::kilo>(format_str, rep);
+    break;
+  case 11:
+    invoke_inner<std::mega>(format_str, rep);
+    break;
+  case 12:
+    invoke_inner<std::giga>(format_str, rep);
+    break;
+  case 13:
+    invoke_inner<std::tera>(format_str, rep);
+    break;
+  case 14:
+    invoke_inner<std::peta>(format_str, rep);
+    break;
+  case 15:
+    invoke_inner<std::exa>(format_str, rep);
+    break;
+  }
+}
+
+extern "C" int LLVMFuzzerTestOneInput(const uint8_t* data, size_t size) {
+  if (size <= 4) return 0;
+
+  const auto representation = data[0];
+  const auto period = data[1];
+  data += 2;
+  size -= 2;
+
+  switch (representation) {
+  case 1:
+    invoke_outer<char>(data, size, period);
+    break;
+  case 2:
+    invoke_outer<signed char>(data, size, period);
+    break;
+  case 3:
+    invoke_outer<unsigned char>(data, size, period);
+    break;
+  case 4:
+    invoke_outer<short>(data, size, period);
+    break;
+  case 5:
+    invoke_outer<unsigned short>(data, size, period);
+    break;
+  case 6:
+    invoke_outer<int>(data, size, period);
+    break;
+  case 7:
+    invoke_outer<unsigned int>(data, size, period);
+    break;
+  case 8:
+    invoke_outer<long>(data, size, period);
+    break;
+  case 9:
+    invoke_outer<unsigned long>(data, size, period);
+    break;
+  case 10:
+    invoke_outer<float>(data, size, period);
+    break;
+  case 11:
+    invoke_outer<double>(data, size, period);
+    break;
+  case 12:
+    invoke_outer<long double>(data, size, period);
+    break;
+  }
+  return 0;
+}
diff --git a/external/fmt/test/fuzzing/chrono-timepoint.cc b/external/fmt/test/fuzzing/chrono-timepoint.cc
new file mode 100644
index 00000000..8a1b24d2
--- /dev/null
+++ b/external/fmt/test/fuzzing/chrono-timepoint.cc
@@ -0,0 +1,32 @@
+// Copyright (c) 2021, Paul Dreik
+// For license information refer to format.h.
+#include <fmt/chrono.h>
+
+#include "fuzzer-common.h"
+
+/*
+ * a fuzzer for the chrono timepoints formatters
+ * C is a clock (std::chrono::system_clock etc)
+ */
+template <typename C> void doit(const uint8_t* data, size_t size) {
+  using Rep = typename C::time_point::rep;
+  constexpr auto N = sizeof(Rep);
+  if (size < N) return;
+
+  const auto x = assign_from_buf<Rep>(data);
+  typename C::duration dur{x};
+  typename C::time_point timepoint{dur};
+  data += N;
+  size -= N;
+  data_to_string format_str(data, size);
+
+  std::string message = fmt::format(format_str.get(), timepoint);
+}
+
+extern "C" int LLVMFuzzerTestOneInput(const uint8_t* data, size_t size) {
+  try {
+    doit<std::chrono::system_clock>(data, size);
+  } catch (...) {
+  }
+  return 0;
+}
diff --git a/external/fmt/test/fuzzing/float.cc b/external/fmt/test/fuzzing/float.cc
new file mode 100644
index 00000000..d4c9e4f5
--- /dev/null
+++ b/external/fmt/test/fuzzing/float.cc
@@ -0,0 +1,39 @@
+// A fuzzer for floating-point formatter.
+// For the license information refer to format.h.
+
+#include <fmt/format.h>
+
+#include <cstdint>
+#include <cstdlib>
+#include <limits>
+#include <stdexcept>
+
+#include "fuzzer-common.h"
+
+void check_round_trip(fmt::string_view format_str, double value) {
+  auto buffer = fmt::memory_buffer();
+  fmt::format_to(std::back_inserter(buffer), format_str, value);
+
+  if (std::isnan(value)) {
+    auto nan = std::signbit(value) ? "-nan" : "nan";
+    if (fmt::string_view(buffer.data(), buffer.size()) != nan)
+      throw std::runtime_error("round trip failure");
+    return;
+  }
+
+  buffer.push_back('\0');
+  char* ptr = nullptr;
+  if (std::strtod(buffer.data(), &ptr) != value)
+    throw std::runtime_error("round trip failure");
+  if (ptr + 1 != buffer.end()) throw std::runtime_error("unparsed output");
+}
+
+extern "C" int LLVMFuzzerTestOneInput(const uint8_t* data, size_t size) {
+  if (size <= sizeof(double) || !std::numeric_limits<double>::is_iec559)
+    return 0;
+  check_round_trip("{}", assign_from_buf<double>(data));
+  // A larger than necessary precision is used to trigger the fallback
+  // formatter.
+  check_round_trip("{:.50g}", assign_from_buf<double>(data));
+  return 0;
+}
